/* fhtml.cpp
 *
 * pte@ddsw.nl
 */

#include <qevent.h>
#include <htmlview.h>
#include <qscrbar.h>
#include "fhtml.moc"

FHtml::FHtml( QWidget *parent, const char *name )
	: QWidget( parent, name )
{
	scroll = new QScrollBar( 0, 1000, 18, 36, 0,
			QScrollBar::Vertical, this, 0 ) ;
	html = new FHtmlWidget( this, 0 ) ;

	// fhtmlwidget mouse-events
	connect( html, SIGNAL(notifyMousePressEvent(QMouseEvent *)),
			SLOT(mousePressEvent(QMouseEvent *)) ) ;
	connect( html, SIGNAL(notifyMouseReleaseEvent(QMouseEvent *)),
			SLOT(mouseReleaseEvent(QMouseEvent *)) ) ;
	connect( html, SIGNAL(notifyMouseMoveEvent(QMouseEvent *)),
			SLOT(mouseMoveEvent(QMouseEvent *)) ) ;

	// scrollbar	
	connect( scroll, SIGNAL(valueChanged(int)),
			SLOT(scrollHtml(int)) ) ;

	resizeEvent(0) ;
}

void FHtml::setHtml( char *s )
{
	html->begin();
	html->write( s );
	html->end() ;
	html->parse() ;

	scroll->setValue( 0 ) ;
}

void FHtml::scrollHtml( int pos )
{
	int newpos = (int)( double(pos * html->docHeight()) / 1000 ) ;
	html->slotScrollVert( newpos ) ;
}

void FHtml::mousePressEvent( QMouseEvent *m )
{
	//KHTMLWidget::mousePressEvent( m ) ;
	emit notifyMousePressEvent( m ) ;
}

void FHtml::mouseReleaseEvent( QMouseEvent *m )
{
	emit notifyMouseReleaseEvent( m ) ;
	//KHTMLWidget::mouseReleaseEvent( m ) ;
}

void FHtml::mouseMoveEvent( QMouseEvent *m )
{
	emit notifyMouseMoveEvent( m ) ;
	//KHTMLWidget::mouseMoveEvent( m ) ;
}

void FHtml::resizeEvent( QResizeEvent * ) 
{
	int h = size().height() ;
	int w = size().width() ;

	html->setGeometry( 0, 0, w-SCROLL_WIDTH, h ) ;
	scroll->setGeometry( w-SCROLL_WIDTH, 0, SCROLL_WIDTH, h ) ;
}

